/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_

  Written using Visual C++ 6.0, but in generic C++; should be platform independent.

 The program:
  'poly2quadArbitraryTestPrnt()' function is a nearly endless loop that:
	-Makes an arbitrary quadrilateral by choosing 4 randomly-generated
		vertices with x,y values between +10 and -10.  Quad may convex, 
		front-or back-facing, a triangle, a chevron (concave). Only 'bow-ties'
		(quads with sides that cross) and lines (4-collinear-points) excluded.
	-randomly chooses a 2D cubic polynomial (all coeffs between -10 and +10)
	-computes the integral of the polynomial within the quadrilateral bounds,
		-by the matrix-based method in the paper, and
		-by jittered super-sampling.  
			Prints a time-keeper mark '.' for every 50 super-samples that land
			inside the quadrilateral.
	-print the answers and the error between them.  If the answers differ by
		more than 1%, print out the x,y coordinates of the quadrilateral's
		corner points too.

  In v_vecmat.cpp, in Matrx::poly2quadMC() function, #define MAXcount sets the
	number of jittered super-samples to use.


  This C++ code is offered only as an illustration of the method described in
	the paper--it is written for clarity, not for speed.  You have my permission
	to use it and modify it in any way you like; all I ask is that you include 
	an acknowlegement in your code such as:

	//'From source code supplied by Jack Tumblin, Northwestern University,
	// from the paper "Exact 2-D Integration inside Quadrilateral Boundaries",
	// Journal of Graphics Tools, Winter 2005, Volume ##, No. #, AK Peters.

	and that you include the published paper in your bibliography if you use it
	in work that leads to another publication.  I'll be glad to answer any 
	reasonable questions about the code or the published method, but please don't 
	ask me to debug your modifications to this code. This source code is offered 
	'as-is' with no warranty about its correctness or suitability for any use.	

	-Jack Tumblin, jet@cs.northwestern.edu 12/14/2004
===============================================================================*/

#include <stdio.h>							// for printf/scanf
#include "v_vecmat.h"						// partial vector/matrix library

int main()
{
Matrx src;
Vec2 tst;

	printf("---Demo code for:----------------------------------------------\n");
	printf("--- \"Exact 2-D Integration Inside Quadrilateral Boundaries\" ---\n");
	printf("---     in: Journal Of Graphics Tools, Winter 2005          ---\n");
	printf("---                                                         ---\n");
	printf("--- Jack Tumblin,Northwestern Univ. jet@cs.northwestern.edu --- \n");
	printf("\n\nBegin Tests:\n\n");

//	src.poly2convexQuadTestPrnt();		// Test convex quadrilaterals only.

	src.poly2arbitraryQuadTestPrnt();	// Test arbitrary quadrilaterals.
	

	
	return(0);
}